diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/argsresources.c vnc_unixsrc/vncviewer/argsresources.c
--- vnc_unixsrc.orig/vncviewer/argsresources.c	2007-02-04 17:10:31.000000000 -0500
+++ vnc_unixsrc/vncviewer/argsresources.c	2010-04-18 12:39:55.000000000 -0400
@@ -206,11 +816,13 @@
   {"bumpScrollPixels", "BumpScrollPixels", XtRInt, sizeof(int),
    XtOffsetOf(AppData, bumpScrollPixels), XtRImmediate, (XtPointer) 20},
 
+  /* hardwired compress -1 vs . 7 */
   {"compressLevel", "CompressionLevel", XtRInt, sizeof(int),
    XtOffsetOf(AppData, compressLevel), XtRImmediate, (XtPointer) -1},
 
+  /* hardwired quality was 6 */
   {"qualityLevel", "QualityLevel", XtRInt, sizeof(int),
-   XtOffsetOf(AppData, qualityLevel), XtRImmediate, (XtPointer) 6},
+   XtOffsetOf(AppData, qualityLevel), XtRImmediate, (XtPointer) -1},
 
   {"enableJPEG", "EnableJPEG", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, enableJPEG), XtRImmediate, (XtPointer) True},
@@ -218,14 +830,97 @@
   {"useRemoteCursor", "UseRemoteCursor", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, useRemoteCursor), XtRImmediate, (XtPointer) True},
 
+  {"useCursorAlpha", "UseCursorAlpha", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useCursorAlpha), XtRImmediate, (XtPointer) False},
+
+  {"useRawLocal", "UseRawLocal", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useRawLocal), XtRImmediate, (XtPointer) False},
+
+  {"notty", "NoTty", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, notty), XtRImmediate, (XtPointer) False},
+
   {"useX11Cursor", "UseX11Cursor", XtRBool, sizeof(Bool),
    XtOffsetOf(AppData, useX11Cursor), XtRImmediate, (XtPointer) False},
 
+  {"useBell", "UseBell", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useBell), XtRImmediate, (XtPointer) True},
+
   {"grabKeyboard", "GrabKeyboard", XtRBool, sizeof(Bool),
-   XtOffsetOf(AppData, grabKeyboard), XtRImmediate, (XtPointer) False},
+   XtOffsetOf(AppData, grabKeyboard), XtRImmediate, (XtPointer) True},
 
   {"autoPass", "AutoPass", XtRBool, sizeof(Bool),
-   XtOffsetOf(AppData, autoPass), XtRImmediate, (XtPointer) False}
+   XtOffsetOf(AppData, autoPass), XtRImmediate, (XtPointer) False},
+
+  {"grabAll", "GrabAll", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, grabAll), XtRImmediate, (XtPointer) False},
+
+  {"useXserverBackingStore", "UseXserverBackingStore", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, useXserverBackingStore), XtRImmediate, (XtPointer) False},
+
+  {"overrideRedir", "OverrideRedir", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, overrideRedir), XtRImmediate, (XtPointer) True},
+
+  {"serverInput", "ServerInput", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, serverInput), XtRImmediate, (XtPointer) True},
+
+  {"singleWindow", "SingleWindow", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, singleWindow), XtRImmediate, (XtPointer) False},
+
+  {"serverScale", "ServerScale", XtRInt, sizeof(int),
+   XtOffsetOf(AppData, serverScale), XtRImmediate, (XtPointer) 1},
+
+  {"chatActive", "ChatActive", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, chatActive), XtRImmediate, (XtPointer) False},
+
+  {"chatOnly", "ChatOnly", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, chatOnly), XtRImmediate, (XtPointer) False},
+
+  {"fileActive", "FileActive", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, fileActive), XtRImmediate, (XtPointer) False},
+
+  {"popupFix", "PopupFix", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, popupFix), XtRImmediate, (XtPointer) False},
+
+  {"scale", "Scale", XtRString, sizeof(String),
+   XtOffsetOf(AppData, scale), XtRImmediate, (XtPointer) 0},
+
+  {"pipelineUpdates", "PipelineUpdates", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, pipelineUpdates), XtRImmediate, (XtPointer)
+#ifdef TURBOVNC
+ True},
+#else
+#if 0
+ False},
+#else
+ True},
+#endif
+#endif
+
+  {"noipv4", "noipv4", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, noipv4), XtRImmediate, (XtPointer) False},
+
+  {"noipv6", "noipv6", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, noipv6), XtRImmediate, (XtPointer) False},
+
+  {"sendClipboard", "SendClipboard", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, sendClipboard), XtRImmediate, (XtPointer) False},
+
+  {"sendAlways", "SendAlways", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, sendAlways), XtRImmediate, (XtPointer) False},
+
+  {"recvText", "RecvText", XtRString, sizeof(String),
+   XtOffsetOf(AppData, recvText), XtRImmediate, (XtPointer) 0},
+
+  {"appShare", "AppShare", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, appShare), XtRImmediate, (XtPointer) False},
+
+  {"escapeKeys", "EscapeKeys", XtRString, sizeof(String),
+   XtOffsetOf(AppData, escapeKeys), XtRImmediate, (XtPointer) 0},
+
+  {"escapeActive", "EscapeActive", XtRBool, sizeof(Bool),
+   XtOffsetOf(AppData, escapeActive), XtRImmediate, (XtPointer) False}
+
+  /* check commas */
 };
 
 
@@ -242,8 +937,29 @@
   {"-noraiseonbeep", "*raiseOnBeep",        XrmoptionNoArg,  "False"},
   {"-passwd",        "*passwordFile",       XrmoptionSepArg, 0},
   {"-user",          "*userLogin",          XrmoptionSepArg, 0},
+  {"-unixpw",        "*unixPW",             XrmoptionSepArg, 0},
+  {"-mslogon",       "*msLogon",            XrmoptionSepArg, 0},
+  {"-repeater",      "*repeaterUltra",      XrmoptionSepArg, 0},
+  {"-ultradsm",      "*ultraDSM",           XrmoptionNoArg,  "True"},
+  {"-acceptpopup",   "*acceptPopup",        XrmoptionNoArg,  "True"},
+  {"-acceptpopupsc", "*acceptPopup",        XrmoptionNoArg,  "True"},
+  {"-rfbversion",    "*rfbVersion",         XrmoptionSepArg, 0},
   {"-encodings",     "*encodings",          XrmoptionSepArg, 0},
-  {"-bgr233",        "*useBGR233",          XrmoptionNoArg,  "True"},
+  {"-bgr233",        "*useBGR233",          XrmoptionNoArg,  "256"},
+  {"-use64",         "*useBGR233",          XrmoptionNoArg,   "64"},
+  {"-bgr222",        "*useBGR233",          XrmoptionNoArg,   "64"},
+  {"-use8",          "*useBGR233",          XrmoptionNoArg,    "8"},
+  {"-bgr111",        "*useBGR233",          XrmoptionNoArg,    "8"},
+  {"-16bpp",         "*useBGR565",          XrmoptionNoArg,  "True"},
+  {"-bgr565",        "*useBGR565",          XrmoptionNoArg,  "True"},
+  {"-grey",          "*useGreyScale",       XrmoptionNoArg,  "True"},
+  {"-gray",          "*useGreyScale",       XrmoptionNoArg,  "True"},
+  {"-sbwidth",       "*sbwidth",            XrmoptionSepArg, 0},
+  {"-env",           "*envDummy",           XrmoptionSepArg, 0},
+  {"-ycrop",         "*yCrop",              XrmoptionSepArg, 0},
+  {"-rawlocal",      "*useRawLocal",        XrmoptionNoArg,  "True"},
+  {"-notty",         "*notty",              XrmoptionNoArg,  "True"},
+  {"-alpha",         "*useCursorAlpha",     XrmoptionNoArg,  "True"},
   {"-owncmap",       "*forceOwnCmap",       XrmoptionNoArg,  "True"},
   {"-truecolor",     "*forceTrueColour",    XrmoptionNoArg,  "True"},
   {"-truecolour",    "*forceTrueColour",    XrmoptionNoArg,  "True"},
@@ -253,8 +969,30 @@
   {"-nojpeg",        "*enableJPEG",         XrmoptionNoArg,  "False"},
   {"-nocursorshape", "*useRemoteCursor",    XrmoptionNoArg,  "False"},
   {"-x11cursor",     "*useX11Cursor",       XrmoptionNoArg,  "True"},
-  {"-autopass",      "*autoPass",           XrmoptionNoArg,  "True"}
-
+  {"-nobell",        "*useBell",            XrmoptionNoArg,  "False"},
+  {"-autopass",      "*autoPass",           XrmoptionNoArg,  "True"},
+  {"-graball",       "*grabAll",            XrmoptionNoArg,  "True"},
+  {"-grabkbd",       "*grabKeyboard",       XrmoptionNoArg,  "True"},
+  {"-nograbkbd",     "*grabKeyboard",       XrmoptionNoArg,  "False"},
+  {"-grabkeyboard",  "*grabKeyboard",       XrmoptionNoArg,  "True"},
+  {"-nograbkeyboard","*grabKeyboard",       XrmoptionNoArg,  "False"},
+  {"-nooverride",    "*overrideRedir",      XrmoptionNoArg,  "False"},
+  {"-bs",            "*useXserverBackingStore",    XrmoptionNoArg,  "True"},
+  {"-nobs",          "*useXserverBackingStore",    XrmoptionNoArg,  "False"},
+  {"-popupfix",      "*popupFix",           XrmoptionNoArg,  "True"},
+  {"-noshm",         "*useShm",             XrmoptionNoArg,  "False"},
+  {"-termchat",      "*termChat",           XrmoptionNoArg,  "True"},
+  {"-chatonly",      "*chatOnly",           XrmoptionNoArg,  "True"},
+  {"-scale",         "*scale",              XrmoptionSepArg, 0},
+  {"-appshare",      "*appShare",           XrmoptionNoArg,  "True"},
+  {"-escape",        "*escapeKeys",         XrmoptionSepArg, 0},
+  {"-sendclipboard", "*sendClipboard",      XrmoptionNoArg,  "True"},
+  {"-sendalways",    "*sendAlways",         XrmoptionNoArg,  "True"},
+  {"-recvtext",      "*recvText",           XrmoptionSepArg, 0},
+  {"-pipeline",      "*pipelineUpdates",    XrmoptionNoArg,  "True"},
+  {"-nopipeline",    "*pipelineUpdates",    XrmoptionNoArg,  "False"},
+  {"-noipv4",        "*noipv4",             XrmoptionNoArg,  "True"},
+  {"-noipv6",        "*noipv6",             XrmoptionNoArg,  "True"}
 };
 
 int numCmdLineOptions = XtNumber(cmdLineOptions);
@@ -267,16 +1005,100 @@
 static XtActionsRec actions[] = {
     {"SendRFBEvent", SendRFBEvent},
     {"ShowPopup", ShowPopup},
+    {"Noop", Noop},
     {"HidePopup", HidePopup},
+    {"HideScaleN", HideScaleN},
+    {"HideTurboVNC", HideTurboVNC},
+    {"HideQuality", HideQuality},
+    {"HideCompress", HideCompress},
     {"ToggleFullScreen", ToggleFullScreen},
+    {"JumpLeft", JumpLeft},
+    {"JumpRight", JumpRight},
+    {"JumpUp", JumpUp},
+    {"JumpDown", JumpDown},
     {"SetFullScreenState", SetFullScreenState},
     {"SelectionFromVNC", SelectionFromVNC},
     {"SelectionToVNC", SelectionToVNC},
     {"ServerDialogDone", ServerDialogDone},
+    {"UserDialogDone", UserDialogDone},
+    {"YCropDialogDone", YCropDialogDone},
+    {"ScbarDialogDone", ScbarDialogDone},
+    {"ScaleNDialogDone", ScaleNDialogDone},
+    {"ScaleDialogDone", ScaleDialogDone},
     {"PasswordDialogDone", PasswordDialogDone},
     {"Pause", Pause},
     {"RunCommand", RunCommand},
     {"Quit", Quit},
+    {"HideChat", HideChat},
+    {"Toggle8bpp", Toggle8bpp},
+    {"Toggle16bpp", Toggle16bpp},
+    {"ToggleFullColor", ToggleFullColor},
+    {"Toggle256Colors", Toggle256Colors},
+    {"Toggle64Colors", Toggle64Colors},
+    {"Toggle8Colors", Toggle8Colors},
+    {"ToggleGreyScale", ToggleGreyScale},
+    {"ToggleTightZRLE", ToggleTightZRLE},
+    {"ToggleTightHextile", ToggleTightHextile},
+    {"ToggleZRLEZYWRLE", ToggleZRLEZYWRLE},
+    {"ToggleViewOnly", ToggleViewOnly},
+    {"ToggleJPEG", ToggleJPEG},
+    {"ToggleCursorShape", ToggleCursorShape},
+    {"ToggleCursorAlpha", ToggleCursorAlpha},
+    {"ToggleX11Cursor", ToggleX11Cursor},
+    {"ToggleBell", ToggleBell},
+    {"ToggleRawLocal", ToggleRawLocal},
+    {"ToggleServerInput", ToggleServerInput},
+    {"TogglePipelineUpdates", TogglePipelineUpdates},
+    {"ToggleSendClipboard", ToggleSendClipboard},
+    {"ToggleSendAlways", ToggleSendAlways},
+    {"ToggleSingleWindow", ToggleSingleWindow},
+    {"ToggleTextChat", ToggleTextChat},
+    {"ToggleFileXfer", ToggleFileXfer},
+    {"ToggleXGrab", ToggleXGrab},
+    {"DoServerScale", DoServerScale},
+    {"SetScale", SetScale},
+    {"SetYCrop", SetYCrop},
+    {"SetScbar", SetScbar},
+    {"ShowScaleN", ShowScaleN},
+    {"ShowTurboVNC", ShowTurboVNC},
+    {"ShowQuality", ShowQuality},
+    {"ShowCompress", ShowCompress},
+    {"SetScaleN", SetScaleN},
+    {"SetTurboVNC", SetTurboVNC},
+    {"SetQuality", SetQuality},
+    {"SetCompress", SetCompress},
+    {"Set8bppState", Set8bppState},
+    {"Set16bppState", Set16bppState},
+    {"SetFullColorState", SetFullColorState},
+    {"Set256ColorsState", Set256ColorsState},
+    {"Set64ColorsState", Set64ColorsState},
+    {"Set8ColorsState", Set8ColorsState},
+    {"SetGreyScaleState", SetGreyScaleState},
+    {"SetZRLEState", SetZRLEState},
+    {"SetHextileState", SetHextileState},
+    {"SetZYWRLEState", SetZYWRLEState},
+    {"SetNOJPEGState", SetNOJPEGState},
+    {"SetScaleNState", SetScaleNState},
+    {"SetQualityState", SetQualityState},
+    {"SetCompressState", SetCompressState},
+    {"SetViewOnlyState", SetViewOnlyState},
+    {"SetCursorShapeState", SetCursorShapeState},
+    {"SetCursorAlphaState", SetCursorAlphaState},
+    {"SetX11CursorState", SetX11CursorState},
+    {"SetBellState", SetBellState},
+    {"SetRawLocalState", SetRawLocalState},
+    {"SetServerInputState", SetServerInputState},
+    {"SetPipelineUpdates", SetPipelineUpdates},
+    {"SetSendClipboard", SetSendClipboard},
+    {"SetSendAlways", SetSendAlways},
+    {"SetSingleWindowState", SetSingleWindowState},
+    {"SetTextChatState", SetTextChatState},
+    {"SetFileXferState", SetFileXferState},
+    {"SetXGrabState", SetXGrabState},
+    {"SetEscapeKeysState", SetEscapeKeysState},
+    {"ToggleEscapeActive", ToggleEscapeActive},
+    {"EscapeDialogDone", EscapeDialogDone},
+    {"SetEscapeKeys", SetEscapeKeys}
 };
 
 
@@ -302,11 +1124,14 @@
 void
 usage(void)
 {
-  fprintf(stderr,
-	  "TightVNC viewer version 1.3dev7\n"
+  fprintf(stdout,
+	  "SSVNC Viewer (based on TightVNC viewer version 1.3.9)\n"
 	  "\n"
 	  "Usage: %s [<OPTIONS>] [<HOST>][:<DISPLAY#>]\n"
 	  "       %s [<OPTIONS>] [<HOST>][::<PORT#>]\n"
+	  "       %s [<OPTIONS>] exec=[CMD ARGS...]\n"
+	  "       %s [<OPTIONS>] fd=n\n"
+	  "       %s [<OPTIONS>] /path/to/unix/socket\n"
 	  "       %s [<OPTIONS>] -listen [<DISPLAY#>]\n"
 	  "       %s -help\n"
 	  "\n"
@@ -319,7 +1144,7 @@
 	  "        -noraiseonbeep\n"
 	  "        -passwd <PASSWD-FILENAME> (standard VNC authentication)\n"
 	  "        -user <USERNAME> (Unix login authentication)\n"
-	  "        -encodings <ENCODING-LIST> (e.g. \"tight copyrect\")\n"
+	  "        -encodings <ENCODING-LIST> (e.g. \"tight,copyrect\")\n"
 	  "        -bgr233\n"
 	  "        -owncmap\n"
 	  "        -truecolour\n"
